﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using NormalManyToMany;
using SimpleManyToMany;

namespace FluentNHibernateSimpleVsNormal
{
    class Program
    {
        static void Main(string[] args)
        {
            DateTime startTime;
            TimeSpan elapsedTime;

            // track insert record timing for normal many-to-many setup
            NormalManyToMany.CRUDOperations NormalCRUD = new NormalManyToMany.CRUDOperations();

            GC.Collect();

            // read first names
            List<string> firstNameList = new List<string>();
            using (StreamReader sr = new StreamReader(@"..\..\firstnames.txt"))
            {
                string line;
                while ((line = sr.ReadLine()) != null)
                    firstNameList.Add(line);
            }

            // time the inserts
            startTime = DateTime.Now;
            foreach (var name in firstNameList)
            {
                NormalCRUD.CreateStudent(name);
            }
            elapsedTime = DateTime.Now - startTime;

            Console.WriteLine("INSERT NORMAL:" + elapsedTime.ToString());

            // normal select
            startTime = DateTime.Now;
            var StudentList2 = NormalCRUD.SelectAllStudents();
            elapsedTime = DateTime.Now - startTime;

            Console.WriteLine("SELECT NORMAL:" + elapsedTime.ToString());

            // normal delete
            startTime = DateTime.Now;
            NormalCRUD.DeleteStudents();
            elapsedTime = DateTime.Now - startTime;

            Console.WriteLine("DELETE NORMAL:" + elapsedTime.ToString());


            // track insert record timing for simple many-to-many setup
            SimpleManyToMany.CRUDOperations EasyCRUD = new SimpleManyToMany.CRUDOperations();
            
            GC.Collect();

            // easy inserts
            startTime = DateTime.Now;
            foreach (var name in firstNameList)
            {
                EasyCRUD.CreateStudent(name);
            }
            elapsedTime = DateTime.Now - startTime;

            Console.WriteLine("INSERT EASY:" + elapsedTime.ToString());

            // easy select
            startTime = DateTime.Now;
            var StudentList = EasyCRUD.SelectAllStudents();
            elapsedTime = DateTime.Now - startTime;

            Console.WriteLine("SELECT EASY:" + elapsedTime.ToString());

            // easy delete
            startTime = DateTime.Now;
            EasyCRUD.DeleteStudents();
            elapsedTime = DateTime.Now - startTime;

            Console.WriteLine("DELETE EASY:" + elapsedTime.ToString());

            Console.ReadKey();
        }
    }
}
