﻿using FluentNHibernate.Mapping;
using System.Collections.Generic;

namespace NormalManyToMany
{
    public class Student
    {
        public virtual int Id { get; set; }
        public virtual string Name { get; set; }
        public virtual IList<Class> Class { get; set; }

        public Student()
        {
            Class = new List<Class>();
        }
    }

    public class StudentMap : ClassMap<Student>
    {
        public StudentMap()
        {
            Id(u => u.Id).GeneratedBy.Identity();
            Map(u => u.Name).Nullable();
            HasManyToMany(u => u.Class)
                .Table("studentdata..student2class")
                .ParentKeyColumn("StudentId")
                .ChildKeyColumn("ClassId")
                .LazyLoad();
                

            Table("studentdata..Student");
        }
    }
}