﻿using System;
using System.Linq;
using NHibernate;
using NHibernate.Linq;
using System.Collections.Generic;

namespace SimpleManyToMany
{
    public class CRUDOperations
    {
        public void CreateStudent(string studentName)
        {
            using (ISession db = MSSQLSessionFactory.OpenSession())
            {
                Student student = new Student()
                {
                    Name = studentName
                };

                db.Save(student);
            }
        }

        public IList<string> SelectAllStudents()
        {
            using (ISession db = MSSQLSessionFactory.OpenSession())
            {
                return (from s in db.Query<Student>() select s.Name).ToList();
            }
        }

        public void DeleteStudents()
        {
            using (ISession db = MSSQLSessionFactory.OpenSession())
            {
                var studentQuery = (from s in db.Query<Student>() select s).ToList();
                using (db.BeginTransaction())
                {
                    foreach (var item in studentQuery)
                    {
                        db.Delete(item);
                    }
                    db.Transaction.Commit();
                }
            }
        }
    }
}
